/*

*/

// This section describes the vehicle

// Variables used in the program
byte ID = 22; // Vehicle ID Number
int Active = 0; // Variable to determine if the tractor is in active
int Last_Data_Timer = 0;
int Controller_Locked = 0;
int Receive_Count = 0;

int Controller_ID = 0;

uint8_t buf[16]; // Array to store recieved data

#include <SPI.h>
#include "RCTractorGuyRF24.h"
#include "RCTractorGuynRF24L01.h"
#include "RCTractorGuy_Excavator.h"

// Set up nRF24L01 radio on SPI bus plus pins 9 & 10
RF24 radio(9, 10);

// Initialise Tractor
/*(Motor_1_PWM, Motor_1_Dir_1, Motor_1_Dir_2, Motor_2_PWM, Motor_2_Dir_1, Motor_2_Dir_2,
Steering, Rear_Link, Front_Link, Left_Ind, Right_Ind, Head_Lights, Tail_Lights, Work_Lights,
Accessory_Lights, Left_Beacon, Right_Beacon)*/
RCExcavator PC400;

// Controller Address
const uint64_t Controller[5] = { 0xE8E8F0F0E1LL, 0xE8E8F0F0E2LL, 0xE8E8F0F0E3LL, 0xE8E8F0F0E4LL, 0xE8E8F0F0E5LL};
const uint64_t Controller_Listen[5] = { 0x3A3A3A3AD1LL, 0x3A3A3A3AD2LL, 0x3A3A3A3AD3LL, 0x3A3A3A3AD4LL, 0x3A3A3A3AD5LL };

void setup(void)
{
  // Start the NRF24L01
  radio.begin();

Serial.begin(9600);

  radio.openReadingPipe(1, Controller[0]); // Set Address of Controller 1
  radio.openReadingPipe(2, Controller[1]); // Set Address of Controller 2
  radio.openReadingPipe(3, Controller[2]); // Set Address of Controller 1
  radio.openReadingPipe(4, Controller[3]); // Set Address of Controller 2
  radio.openReadingPipe(5, Controller[4]); // Set Address of Controller 2

  radio.startListening();

  PC400.Bucket_Setup(1,0,0,0,0);
  PC400.Extend_Setup(1,0,0,0,0);
  PC400.Raise_Setup(1,0,0,0,0);
  PC400.Slew_Setup(1,0,0,0);
  PC400.Track_Setup(1,0,0,0,0,0,0);   
}

void loop(void)
{

    buf[0] = 0;

    if ( radio.available() )
    {
        // Fetch the payload.
       radio.read( buf, sizeof(buf));

      // We recieved a string of ten bytes, four ID, one command and six data values but they may not be for this tractor
      if (buf[0] == ID) { // Confirm that the correct vehicle ID has been recieved


      int pipe_num = buf[11];

      long Vehicle_Voltage = PC400.ReadVcc();

     // First, stop listening so we can talk
      radio.stopListening();

      // Open the correct pipe for writing
      radio.openWritingPipe(Controller_Listen[pipe_num]);

      // Send battery voltage back.
      radio.write( &Vehicle_Voltage, sizeof(Vehicle_Voltage) );

      // Now, resume listening so we catch the next packets.
      radio.startListening();

	PC400.Control(buf[3],buf[2],buf[4],buf[1],buf[5],buf[7]);
        PC400.Lights(buf[9]);        // Update the lights

        Last_Data_Timer = 10000;
        if(Active != 1){
        PC400.Sleep(1);
        Active = 1;
      }
      }
    }
    else if (Last_Data_Timer != 0) {
      Last_Data_Timer = Last_Data_Timer - 1;
    }
    else if (Last_Data_Timer == 0 && Active == 1) {
      Active = 0;
      PC400.Sleep(0);
      PC400.Lights(0x03);
    }

    PC400.Timer();


    /* if (Active == 1) {
      }
      else if (Controller_Locked != 0) {
       All_Controllers();
       Controller_Locked = 0;
      }*/

}
